<template>
  <ul class="users_list">
    <li
      v-for="(user, index) in handleFilteredUsers"
      :key="index"
      class="user_item"
      :id="user.login.uuid"
    >
      <router-link class="link" :to="`/user/${user.login.uuid}`">
        <div>
          <i class="fa fa-male gender" v-if="user.gender === 'male'"></i>
          <i class="fa fa-female gender" v-if="user.gender === 'female'"></i>
        </div>
        <div class="name_email">
          <div>
            <p class="fullname">
              {{user.name.title}}.
              {{user.name.first}}
              {{user.name.last}}
              ({{user.nat}})
            </p>
          </div>
          <p>
            <i class="fa fa-envelope icon"></i>
            {{user.email}}
          </p>
        </div>
        <div class="extra_info">
          <p>
            <i class="fa fa-birthday-cake icon"></i>
            {{ new Date(`${user.dob.date}`).toLocaleDateString() }}
          </p>
          <p>
            <i class="fa fa-sign-in icon"></i>
            {{ new Date(`${user.registered.date}`).toLocaleDateString() }}
          </p>
        </div>
      </router-link>
    </li>
  </ul>
</template>

<script>
export default {
  name: "UserList",
  data() {
    return {
      filteredUsers: []
    };
  },
  props: {
    users: Array,
    genderSelected: String,
    ageSelected: String,
    nationalitySelected: String
  },
  computed: {
    handleFilteredUsers() {
      let filtered;
      
      filtered = this.users.filter(user => {
        if (
          user.gender === this.genderSelected ||
          user.dob.age.toString() === this.ageSelected ||
          user.nat === this.nationalitySelected
        ) {
          return user;
        }
      });
      if (filtered.length < 1) {
        filtered = this.users;
      }
      return filtered;
    }
  }
};
</script>

<style scoped>
.user_item {
  display: flex;
  box-shadow: 0 4px 2px -1px #2c3e50;
  width: 70%;
  margin-bottom: 40px;
  padding: 20px;
}
@media all and (max-width: 768px) {
  .user_item {
    width: 90%;
  }
}
.extra_info {
  display: flex;
  flex-direction: column;
  align-items: flex-end;
}
.users_list {
  margin-top: 150px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}
.name_email {
  display: flex;
  flex-direction: column;
  align-items: center;
  margin-left: 15px;
}
.hidden {
  display: none;
}
.link {
  display: flex;
  text-decoration: none;
  color: #2c3e50;
  width: 100%;
  justify-content: space-between;
  align-items: center;
}
.gender {
  font-size: 36px;
}
.icon {
  font-size: 24px;
  margin-right: 10px;
}
.fullname {
  font-size: 26px;
}
</style>
